"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ftTransferCall = exports.ftTransfer = exports.ftBalanceOf = exports.ftOrNativeNearMetadata = exports.ftMetadata = void 0;
const utils_1 = require("@tonic-foundation/utils");
const bn_js_1 = __importDefault(require("bn.js"));
const native_near_1 = require("./native-near");
__exportStar(require("./native-near"), exports);
__exportStar(require("./types"), exports);
function ftMetadata(account, tokenId) {
    return __awaiter(this, void 0, void 0, function* () {
        return yield account.viewFunction(tokenId, 'ft_metadata', {});
    });
}
exports.ftMetadata = ftMetadata;
function ftOrNativeNearMetadata(account, tokenId) {
    return __awaiter(this, void 0, void 0, function* () {
        if (tokenId.toUpperCase() === 'NEAR') {
            return native_near_1.NEAR_METADATA;
        }
        return ftMetadata(account, tokenId);
    });
}
exports.ftOrNativeNearMetadata = ftOrNativeNearMetadata;
/**
 * Get balance of the account as a BN
 */
const ftBalanceOf = (account, tokenId, accountId) => __awaiter(void 0, void 0, void 0, function* () {
    return account
        .viewFunction(tokenId, 'ft_balance_of', { account_id: accountId })
        .then((n) => new bn_js_1.default(n))
        .catch(() => {
        return new bn_js_1.default(0);
    });
});
exports.ftBalanceOf = ftBalanceOf;
function ftTransfer(account, tokenId, args, gas = (0, utils_1.tgasAmount)(30), attachedDeposit = new bn_js_1.default(1)) {
    return __awaiter(this, void 0, void 0, function* () {
        return yield (0, utils_1.functionCallWithOutcome)(account, {
            contractId: tokenId,
            methodName: 'ft_transfer',
            args: {
                receiver_id: args.receiverId,
                amount: args.amount.toString(),
            },
            gas,
            attachedDeposit,
        });
    });
}
exports.ftTransfer = ftTransfer;
function ftTransferCall(account, tokenId, args, gas = (0, utils_1.tgasAmount)(100), attachedDeposit = new bn_js_1.default(1)) {
    return __awaiter(this, void 0, void 0, function* () {
        return yield (0, utils_1.functionCallWithOutcome)(account, {
            contractId: tokenId,
            methodName: 'ft_transfer_call',
            args: {
                receiver_id: args.receiverId,
                amount: args.amount.toString(),
                msg: args.msg,
            },
            gas,
            attachedDeposit,
        });
    });
}
exports.ftTransferCall = ftTransferCall;
